#!/usr/bin/env python
"""
Copyright (C) 2001 Greg Berenfield

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Todo's

1.  Load/Save playlists
2.  bookmarks
3.  randomized (shuffle) play
4.  button support
"""
from types import *

import sys
sys.path.append('/usr/local/lib/python2.0')

#CANDIDATE FOR REMOVAL   if sys.version[:3] == '1.4':
#	print "hitting ni import"
#	import ni
import mix
from gtk import *
import libglade
from utils import *
import re
import os
import signal
import string
import time
import select
import getopt
import commands
import pwd
import fileinput
import stat
termios = None


# ------------------------------------------
for MIXER in ["dev/mixer"]:
    if os.path.exists(MIXER): break
user_home_dir = pwd.getpwuid(os.getuid())[5]
playlist_file = '.pypaq.mp3.playlist'
rcfile = '.pypaq.mp3rc'
file_location = user_home_dir[:]

if os.access('%s/%s' % (user_home_dir, rcfile), os.F_OK):
    try:
        f = open('%s/%s'%(user_home_dir,rcfile),'r')
        rcfile_ver = string.strip(f.readline())
        playlist_file = string.strip(f.readline())
        glade_file = string.strip(f.readline())
	#print glade_file
        file_location = string.strip(f.readline())
        savedcolors = string.strip(f.readline())
	f.close()
    except:
        print 'Error Reading %s/%s' % (user_home_dir,rcfile)
        print 'Make sure the syntax of the rcfile is:'
        print 'line1 == rcfile version #'
        print 'line2 == full path to playlist file'
        print 'line3 == full path to galde file'
        print 'line4 == root directory to search for mp3 files in'
        sys.exit(1)
else:
    #It wasn't there, so a default one create it
    f = open('%s/%s' % (user_home_dir, rcfile),'w')
    f.write('.01\n%s/%s\n%s\n%s\n' % (user_home_dir,playlist_file, glade_file,file_location))
    f.close()

if not os.access(glade_file,os.F_OK):
    print 'Could not find glade file at %s' % glade_file
    sys.exit(1)

temp_song_list = []

def isDir(path):
    return stat.S_ISDIR(os.stat(path)[stat.ST_MODE])

valid_string_chars = '%s%s%s' % (string.digits,string.letters,string.whitespace)
def stringStrip(char):
    return char in valid_string_chars

class Playlist:
    def __init__(self,widget,file=None):
        self.playlist_file = file
        self.list_widget = widget
        self.list_items = []
        if file:
            if os.access(file, os.F_OK):
                for each in fileinput.input(file):
                    each = string.strip(each)
                    self.append(each,widget)

    def append(self,file,widget=None):
        #Check to see if I can access the file
        if os.access(file,os.F_OK):
            #See if it is a directory ... 
            if isDir(file):
                 return 0
            new_item = GtkListItem(file)
            new_item.set_data('file_name',file)
            new_item.show()
            self.list_widget.append_items([new_item])
            self.list_items.append(new_item)
            return 1
        else:
            return 0
    def down(self,item):
	    for each in self.list_items:
		    if each == item[0]:
			    pos=self.position(each)
			    len=self.length()
			    if pos<len:
				    hold=self.list_items[pos+1]
				    self.list_items[pos+1]=each
				    self.list_items[pos]=hold
				    self.list_widget.remove_items(item)
				    self.list_widget.insert_items([each],pos+1)
				    return 1
    def up(self,item):
	    for each in self.list_items:
		    if each == item[0]:
			    pos=self.position(each)
			    if pos>0:
				    hold=self.list_items[pos-1]
				    self.list_items[pos-1]=each
				    self.list_items[pos]=hold
				    self.list_widget.remove_items(item)
				    self.list_widget.insert_items([each],pos-1)
				    return 1
			    
    def remove(self,item):
        for each in self.list_items:
            if each == item[0]:
                self.list_widget.remove_items(item)
                self.list_items.remove(each)
                return 1
        else:
            return 0

    def position(self,item):
        c = 0 
        for each in self.list_items:
            if each == item:
                return c
            else:
                c = c + 1
        return 0

    def length(self):
        c = 0
        for each in self.list_items:
            c = c + 1
        return c

    def save(self,file=None):
        if file:
            if os.access(file,os.F_OK):
                if isDir(file):
                    return 0
                else:
                    self.playlist_file = file

        if self.playlist_file:
            try:
                f = open(self.playlist_file,'w')
                for each in self.list_items:
                    f.write('%s\n' % each.get_data('file_name'))
                f.close()
            except:
                return 0
        else:
            return 0

def which(program):
    for path in string.split(os.environ["PATH"], ":"):
        if os.path.exists(os.path.join(path, program)):
            return os.path.join(path, program)
def createSubTree(item,path):    
    item_subtree = None
    mylist=os.listdir(path)
    mylist.sort()
    for each in mylist:
	    if os.path.isdir(path+each):
		    item_new = GtkTreeItem(each)
                    item_new.set_data('song','%s%s' % (path,each))  # greps directories
		    item.append(item_new)
		    item_subtree = GtkTree()
		    item_subtree.connect('select-child',toggle_song_select)
		    item_new.set_subtree(item_subtree)
		    createSubTree(item_subtree,path+each+'/',)
		    item_new.show()
	    else:
		    item_subtree = GtkTree()
		    item_new = GtkTreeItem(each)
		    item_new.set_data('song','%s%s' % (path,each))
		    item.append(item_new)
		    item_new.show()
	    
def toggle_song_select(tree,item):
    global temp_song_list
    song = item.get_data('song')
    #print "intoggleselect with song: "+song
    if song!=None:
        if os.path.isdir(song):
            mygrep=os.listdir(song)
            mygrep.sort()
            for each in mygrep:
                if os.path.isdir(song+'/'+each):
                    mygrep.remove(each)
            for each in mygrep:
                #print song+'/'+each
                testitem=song+'/'+each
                if testitem in temp_song_list:
                    temp_song_list.remove(song+'/'+each)
                else:
		    temp_song_list.append(song+'/'+each)
        else:
	    if song in temp_song_list:
		    temp_song_list.remove(song)
	    else:
		    temp_song_list.append(song)
def next_song(index):
	global app
	
	#app.widgets['progress'].get_adjustment().set_value(0)
	app.widgets['time_label'].set_text('elapsed: 0h:0m:0s')
	app.widgets['play_button'].children()[0].set_text('Play')
	#song="\'"
	app.fgo=1;
	app.widgets['playlist'].select_item(index)
	app.current_song_item=app.widgets['playlist'].get_selection()[0]
	#song+=app.current_song_item.get_data('file_name')+"\'"
	song = app.current_song_item.get_data('file_name')
	#print song
	rip = re.compile("(\d+):(\d+):(\d+)")
        n1=string.replace(song,' ','\ ')
        n2=string.replace(n1,'\"','\\\"')
        n3=string.replace(n2,'(','\(')
        n4=string.replace(n3,')','\)')
        n5=string.replace(n4,'\'','\\\'')
        n6=string.replace(n5,'&','\\&')
        pfdstr="madtime "+n6+""
	pfd=os.popen(pfdstr)
	pstr=pfd.read()
	#print pstr+"is the output from pfdstr of: "+pfdstr
	m=rip.search(pstr)
        if m:
            h1, m1, s1, = map(string.atof, m.groups())
        else:
            print "no grep from rip.search for song named: "+song
	sstr="length: "+str(int(round(h1)))+"h:"+str(int(round(m1)))+"m:"+str(int(round(s1)))+"s"
	#print "my grep of this is "+sstr
	app.widgets['total_time_label'].set_text(sstr)
	app.player.maxsecs=(m1*60)+(3600*h1)+s1
	my_adjustment = GtkAdjustment(0,0,app.player.maxsecs,1,5,1)
	my_adjustment.connect('value_changed',on_progress_value_change)
	app.widgets['progress'].set_adjustment(my_adjustment)
	return song
class Player:
    def __init__(self):
        self.stopped = 0
        self.paused = 0
        self.stdout_r, self.stdout_w = os.pipe()
        self.stderr_r, self.stderr_w = os.pipe()
        self.pathname = None
        self.filename = None
        self.seek_step = 0
        self.time_done = None
        self.time_left = None
	self.fbd=''

    def is_stopped(self):
        return self.stopped

    def is_paused(self):
        return self.paused

    def play(self):
	#print "playing..."
        self.pid = os.fork()
        if self.pid == 0:
            signal.signal(signal.SIGTERM, signal.SIG_DFL)
            os.dup2(self.stdout_w, sys.stdout.fileno())
            os.dup2(self.stderr_w, sys.stderr.fileno())
            os.setpgrp()
            try: os.execv(self.argv[0], self.argv)
            except: print "hmm dying"; time.sleep(1); os._exit(1)
	#print "seems like it'd be playing.."    
        self.stopped = 0
        self.paused = 0
        self.seek_step = 0

    def pause(self, quiet=0):
	#print "pausing and pause=%d and stop=%d and status is %s" % (self.paused, self.stopped, status)
	self.paused = 1
	try: os.kill(-self.pid, signal.SIGSTOP)
	except os.error: pass
	quiet or 1
	#quiet or app.set_default_status(_("Paused: %s") % self.filename)

    def unpause(self, quiet=0):
	    self.paused = 0
	    try: os.kill(-self.pid, signal.SIGCONT)
	    except os.error: pass
	    quiet or 1
	    
    def stop(self, quiet=0):
	#print "STOPPING and pause=%d and stop=%d  and status is %s" % (self.paused, self.stopped,status)
	self.stopped = 1
	self.is_paused() and self.unpause(quiet)
	try:
		while 1:
			try: os.kill(-self.pid, signal.SIGTERM)
			except os.error: pass
			os.waitpid(self.pid, os.WNOHANG)
	except Exception: pass
	quiet or 1
	#quiet or app.set_default_status(_("Stopped: %s") % self.filename)
	
    def seek(self, direction):
	self.seek_step = self.seek_step or 1
        self.seek_step = self.seek_step * (self.seek_step * direction > 0) + \
                         direction
	#print self.time_done
	#print self.time_left
        time_total = self.time_done + self.time_left
        self.time_done = min(time_total, max(0, self.time_done+self.seek_step))
	self.time_left = time_total - self.time_done
	#print "now timedone is %d" % self.time_done
	#print "now timeleft is %d" % self.time_left
        self.show_position()
        return self.time_done

    ## todo - rewrite?
    def set_time(self, time_done, time_left):
        if self.seek_step: return
        self.time_done = time_done
        self.time_left = time_left
	#print "time_done is %d" % self.time_done
        self.show_position()

    ## todo - rewrite?
    def show_position(self):
        #app.counter(self.time_left)  # todo: toggle mode
        time_total = 1.0 * (self.time_done + self.time_left)
        #app.progress(time_total and self.time_done/time_total or 0)

    def poll(self):
	    global status
	    try: os.waitpid(self.pid, os.WNOHANG)
	    except:
		    if (status=="playing"):
			    return 1

# ------------------------------------------

class mpg123_Player(Player):
    re_progress = re.compile("^ (\d+):(\d+):(\d+).*")
    re_rip1 = re.compile("Title: (.*)Artist: (.*)")
    re_rip2 = re.compile("Album: (.*)Genre: (.*)")
    re_rip3 = re.compile("Year: (.*)Comment: (.*)")
    re_rip42 = re.compile("Title: (.*)Artist: (.*)\s+Album: (.*)Genre: (.*)\s+Year: (.*)Comment: (.*)\n")
    re_rip4 = re.compile("Title/Songname/Content description: (.*)\n+ Lead performer\(s\)/Soloist\(s\): (.*)\n+ Album/Movie/Show title: (.*)\n+ Track number/Position in set: (.*)\n+ Year: (.*)\n+ Content type: (.*)\n+ Comments: (.*)\n+ 00:00",re.S)
    re_files = re.compile(".*\.mp[123]", re.I)

    command = "%s -v -s %d "
    name = "madplay"

    def setup(self, pathname, offset=0):
        self.pathname = pathname
	#print "pathname is "+pathname
        self.filename = os.path.basename(pathname)
	#print "filename is "+self.filename
        executable = which(self.name)
	#print "exec is "+executable
        self.argv = string.split(self.command % (executable, offset))
	self.argv.append(pathname)
        return executable or 0
# ------------------------------------------
class Timeout:
    def __init__(self):
        self.next = 0
        self.dict = {}

    def add(self, timeout, func, args=()):
        tag = self.next = self.next + 1
        self.dict[tag] = (func, args, time.time() + timeout)
        return tag

    def remove(self, tag):
        del self.dict[tag]

    def check(self, now):
        for tag, (func, args, timeout) in self.dict.items():
            if now >= timeout:
                self.remove(tag)
		#print args
                apply(func, args)
        return len(self.dict) and 0.2 or None

class Application:
	
    global GladeSignalHandlers
        
    def __init__(self):
        self.keymapstack = ""
	if len(sys.argv) > 1:
		fname = sys.argv[1]
	else:
		fname = 'pypaq.mp3.glade'
	self.widgets = GladeHelper(glade_file,GladeSignalHandlers)
	signal.signal(signal.SIGCHLD, signal.SIG_IGN)
	signal.signal(signal.SIGHUP, self.handler_quit)
        signal.signal(signal.SIGINT, self.handler_quit)
        signal.signal(signal.SIGTERM, self.handler_quit)
	
	
    def set_default_status(self, message):
        self.default_message = message
        self.status(message)
        XTERM and sys.stderr.write("\033]0;%s\a" % (message or "cplay"))

    def setup(self):
        if termios:
            self.tcattr = termios.tcgetattr(sys.stdin.fileno())
            tcattr = termios.tcgetattr(sys.stdin.fileno())
            tcattr[0] = tcattr[0] & ~(TERMIOS.IXON)
            termios.tcsetattr(sys.stdin.fileno(), TERMIOS.TCSANOW, tcattr)
        
        signal.signal(signal.SIGCHLD, signal.SIG_IGN)
        signal.signal(signal.SIGHUP, self.handler_quit)
        signal.signal(signal.SIGINT, self.handler_quit)
        signal.signal(signal.SIGTERM, self.handler_quit)
        signal.signal(signal.SIGWINCH, self.handler_resize)
        
        self.player =  PLAYERS[0]
        self.timeout = Timeout()
	self.seek_tag = None
        self.start_tag = None
	self.fgo=1
	self.playindex=0
	self.current_song_item = ''
	#self.get_volume()
	self.volume=mix.getvolume()
        self.widgets['vollabel'].set_text("%d" % self.volume)
	self.treble=mix.gettreble()
        self.widgets['trelabel'].set_text("%d" % self.treble)
	self.bass=mix.getbass()
        self.widgets['baslabel'].set_text("%d" % self.bass)
	self.widgets['volume'].get_adjustment().set_value(-self.volume)
	self.widgets['volume'].get_adjustment().connect('value_changed',self.set_volume)
	self.widgets['treble'].get_adjustment().set_value(-self.treble)
	self.widgets['treble'].get_adjustment().connect('value_changed',self.set_treble)
	self.widgets['bass'].get_adjustment().set_value(-self.bass)
	self.widgets['bass'].get_adjustment().connect('value_changed',self.set_bass)
        self.drawable=None
        self.cm=None
        self.ired,self.igreen,self.iblue=savedcolors.split(',')
        self.mystyle=app.widgets['d1'].get_style().copy()
        cm=self.widgets['d1'].get_colormap()
        mcolor=cm.alloc(int(self.ired),int(self.igreen),int(self.iblue))
        self.mystyle.fg[STATE_NORMAL]=mcolor
        
        
        self.widgets['redvs'].get_adjustment().connect('value_changed',self.set_red)
        self.widgets['greenvs'].get_adjustment().connect('value_changed',self.set_green)
        self.widgets['bluevs'].get_adjustment().connect('value_changed',self.set_blue)
    def cleanup(self):
        curses.endwin()
        XTERM and sys.stderr.write("\033]0;%s\a" % "xterm")
        termios and termios.tcsetattr(sys.stdin.fileno(), TERMIOS.TCSADRAIN, self.tcattr)

    def run(self):
	    
        global status
	global csecs
	
	#self.current_song_item=self.widgets['playlist'].get_selection()[0]
        while 1:
	    #print "at start of while 1 run"
	    while events_pending():
		    mainiteration()
            now = time.time()
	    #print now
	    #print status
            timeout = self.timeout.check(now)

	    #if 1:
	    timeout = 0.1
	    if self.player.poll():
		    #print "hit poll!"
		    self.toggle_stop()
		    #status="stopped"
		    #self.widgets['progress'].get_adjustment().set_value(0)
		    #self.widgets['time_label'].set_text('elapsed: 0h:0m:0s')
		    #self.widgets['play_button'].children()[0].set_text('Play')
		    self.playindex+=1
		    if (playlist.length()==self.playindex): self.playindex=0
		    #print playlist.length()
		    #print self.playindex
		    # This makes it actually go back to 1st song in list... or should it just stop??
		    song=next_song(self.playindex)
		    #print "songname grepped as "+song
		    self.play(song)
	    R = [self.player.stderr_r]
            try: r, w, e = select.select(R, [], [], timeout)
	    except select.error: continue

            if self.player.stderr_r in r:
		    #print "status is "+status
		    #print "fgo is %d" % self.fgo
		    if self.fgo:
                        totstr=""
                        while self.fgo:
			    d=os.read(self.player.stderr_r, 500)
                            totstr+=d
			    #print d
			    m = self.player.re_progress.search(d)
			    if m: # grepping an id3 tag
                                self.fgo=0
                                self.widgets['d1'].set_style(app.mystyle)
                                self.widgets['d2'].set_style(app.mystyle)
                                self.widgets['d3'].set_style(app.mystyle)
                                self.widgets['d4'].set_style(app.mystyle)
                                self.widgets['d5'].set_style(app.mystyle)
                                self.widgets['d6'].set_style(app.mystyle)
                                self.widgets['d7'].set_style(app.mystyle)
				m=self.player.re_rip4.search(totstr)
                                if m:
                                    #print "v1"
                                    title, lead, album, track, year, genre, comment = m.groups()
                                    self.widgets['d1'].set_text(title)
                                    self.widgets['d2'].set_text(lead)
                                    self.widgets['d3'].set_text(album)
                                    self.widgets['d4'].set_text(genre)
                                    self.widgets['d5'].set_text(track)
                                    self.widgets['d6'].set_text(year)
                                    self.widgets['d7'].set_text(comment)
                                    #si="Name: "+title+"\nArtist: "+lead
                                    #si+="\nAlbum: "+album+"\nGenre: "+genre+"\nTrack: "+track
                                    #si+="\nYear: "+year+"\nComment: "+comment
                                    #self.widgets['song_info'].set_text(si)
                                m=self.player.re_rip42.search(totstr)
                                if m:
                                    #print "v2"
                                    title, artist, album, genre, year, comment = m.groups()
                                    self.widgets['d1'].set_text(title)
                                    self.widgets['d2'].set_text(artist)
                                    self.widgets['d3'].set_text(album)
                                    self.widgets['d4'].set_text(genre)
                                    #self.widgets['d5'].set_text(track)
                                    self.widgets['d6'].set_text(year)
                                    self.widgets['d7'].set_text(comment)
				    #si="Name: "+title+"\nArtist: "+artist
				    #si+="\nAlbum: "+album+"\nGenre: "+genre
				    #si+="\nYear: "+year+"\nComment: "+comment
				    #self.widgets['d1'].set_text(si)
			    else: # This is the case of no id3 tag so spit out title
                                si=os.path.basename(app.current_song_item.get_data('file_name'))
                                self.widgets['d1'].set_text(si)
                                self.widgets['d2'].set_text('')
                                self.widgets['d3'].set_text('')
                                self.widgets['d4'].set_text('')
                                self.widgets['d5'].set_text('')
                                self.widgets['d6'].set_text('')
                                self.widgets['d7'].set_text('')
                                
                    else:
			    d = os.read(self.player.stderr_r, 20)
			    m = self.player.re_progress.search(d)
			    if m:
				    h1, m1, s1, = map(string.atoi, m.groups())
				    sstr="elapsed: "+str(h1)+"h:"+str(m1)+"m:"+str(s1)+"s"
				    self.widgets['time_label'].set_text(sstr)
				    csecs=s1+(m1*60)+(h1*3600)
				    self.widgets['progress'].get_adjustment().set_value(csecs)
				    #self.widgets['progress'].get_adjustment().value_changed()
				    # move above to set_time?
				    self.player.set_time(csecs, (self.player.maxsecs-csecs))

	    
    def play(self, pathname, offset = 0):
        self.seek_tag = None
        self.start_tag = None
        if pathname is None or offset is None: return
        if not self.player.is_stopped(): self.player.stop(quiet=1)
        for self.player in PLAYERS:
            if self.player.re_files.match(pathname):
		    if self.player.setup(pathname, offset): break
		    else: print "player setup broke"
	    else: print "failing re_files.match"
        else:
            app.status(_("Player not found!"))
            return
        self.player.play()

    def next_song(self):
        if self.start_tag: self.timeout.remove(self.start_tag)
        args = (self.win_playlist.next_song(), 0)
        self.start_tag = self.timeout.add(0.5, self.play, args)

    def prev_song(self):
        if self.start_tag: self.timeout.remove(self.start_tag)
        args = (self.win_playlist.prev_song(), 0)
        self.start_tag = self.timeout.add(0.5, self.play, args)

    def toggle_pause(self):
        if not self.player.is_stopped():
            if self.player.is_paused():
		    self.player.unpause()
		    self.widgets['play_button'].children()[0].set_text('Pause')
            else:
		    self.player.pause()
		    self.widgets['play_button'].children()[0].set_text('Play')

    def toggle_stop(self):
	    if not self.player.is_stopped(): self.player.stop()
	    else: self.play(self.player.pathname, self.player.time_done)

    def seek(self, direction):
        if self.player.is_stopped(): return
        if self.seek_tag: self.timeout.remove(self.seek_tag)
        args = (self.player.pathname, self.player.seek(direction))
	#args is self.time_done... me things
	#print "path is "+self.player.pathname
	#print args
        self.seek_tag = self.timeout.add(0.5, self.play, args)
    def set_volume(self,v):
        v=app.widgets['volume'].get_adjustment().value
        self.widgets['vollabel'].set_text("%d" % -v)
        mix.setvolume(-v)
    def set_treble(self,v):
        v=app.widgets['treble'].get_adjustment().value
        self.widgets['trelabel'].set_text("%d" % -v)
	mix.settreble(-v)
    def set_bass(self,v):
        v=app.widgets['bass'].get_adjustment().value
        self.widgets['baslabel'].set_text("%d" % -v)
        mix.setbass(-v)
    def set_red(self,val):
        val=app.widgets['redvs'].get_adjustment().value
        green=app.widgets['greenvs'].get_adjustment().value
        blue=app.widgets['bluevs'].get_adjustment().value
        #print "red is %d" % val
        mycolor=app.cm.alloc(val,green,blue)
        mygc=app.drawable.new_gc()        
        mygc.foreground=mycolor
	max_width = app.drawable.width
	max_height = app.drawable.height
	draw_rectangle(app.drawable, mygc, TRUE, 0, 0, max_width, max_height)
    def set_green(self,val):
        val=app.widgets['greenvs'].get_adjustment().value
        red=app.widgets['redvs'].get_adjustment().value
        blue=app.widgets['bluevs'].get_adjustment().value
        mycolor=app.cm.alloc(red,val,blue)
        mygc=app.drawable.new_gc()        
        mygc.foreground=mycolor
	max_width = app.drawable.width
	max_height = app.drawable.height
	draw_rectangle(app.drawable, mygc, TRUE, 0, 0, max_width, max_height)
    def set_blue(self,val):
        val=app.widgets['bluevs'].get_adjustment().value
        red=app.widgets['redvs'].get_adjustment().value
        green=app.widgets['greenvs'].get_adjustment().value
        mycolor=app.cm.alloc(red,green,val)
        mygc=app.drawable.new_gc()        
        mygc.foreground=mycolor
	max_width = app.drawable.width
	max_height = app.drawable.height
	draw_rectangle(app.drawable, mygc, TRUE, 0, 0, max_width, max_height)
    def quit(self):
        if not self.player.is_stopped(): self.player.stop(quiet=1)
        sys.exit(0)

    def handler_resize(self, sig, frame):
        ## curses trickery
        curses.endwin()
        self.w.refresh()
        self.win_root.resize()
        self.win_root.update()

    def handler_quit(self, sig, frame):
        self.quit()
#--------------------------------------------------------------------------
class GladeSignalHandlers:
	def on_play_button_clicked(evt):
		global app
		global status
		if status=="stopped":
			#app.fgo=1
                        song=next_song(app.playindex)
			#print "songname grepped as "+song
			#app.play("/tmp/fe.mp3")
			app.play(song)
			status="playing"
			app.widgets['play_button'].children()[0].set_text('Pause')
		else:
			status="paused"
			app.toggle_pause()
			#app.widgets['play_button'].children()[0].set_text('Play')

	def  on_stop_button_clicked(evt):
		global status
                if status!='stopped':
                    app.toggle_stop()
                    status="stopped"
                    app.widgets['progress'].get_adjustment().set_value(0)
                    app.widgets['time_label'].set_text('elapsed: 0h:0m:0s')
                    app.widgets['play_button'].children()[0].set_text('Play')

	def on_main_window_destroy(evt):
		global status
		if status=="paused":
			app.toggle_stop()
			app.quit()
			mainquit()
		else:
			app.quit()
			mainquit()
			
	def on_next_button_clicked(evt):
		app.toggle_stop()
		app.widgets['time_label'].set_text('elapsed: 0h:0m:0s')
		app.playindex+=1
		if (playlist.length()==app.playindex): app.playindex=0
		song=next_song(app.playindex)
		app.play(song)
	def on_prev_button_clicked(evt):
		app.toggle_stop()
		app.widgets['time_label'].set_text('elapsed: 0h:0m:0s')
		app.playindex-=1
		if (app.playindex<0): app.playindex=0
		song=next_song(app.playindex)
		app.play(song)
	def on_playlist_select_child(list,child):
		global status
		#si = app.widgets['playlist'].get_selection()[0]
		#song = si.get_data('file_name')
		app.playindex=list.child_position(child)
		# simply sets next song value.. only takes effect after STOP/PLAY both pressed

	def on_remove_file_clicked(evt):        
		if status == 'stopped':
			selection = app.widgets['playlist'].get_selection()
                        if selection:
                                tmp=app.widgets['playlist'].get_selection()[0]
                                tmpos=app.widgets['playlist'].child_position(tmp)
				if playlist.remove(selection):
					playlist.save()
					if (tmpos==playlist.length()):
						app.widgets['playlist'].select_item(tmpos-1)
					else:
						app.widgets['playlist'].select_item(tmpos)
				else:
					MsgBox('Please select an item from the playlist above first').show()
	def on_down_button_clicked(evt):
		if status== 'stopped':
			selection = app.widgets['playlist'].get_selection()
                        tmp=app.widgets['playlist'].get_selection()[0]
			tmpos=app.widgets['playlist'].child_position(tmp)
			if selection:
				if playlist.down(selection):
					playlist.save()
                                        app.widgets['playlist'].select_item(tmpos+1)
	def on_up_button_clicked(evt):
		if status== 'stopped':
			selection = app.widgets['playlist'].get_selection()
                        tmp=app.widgets['playlist'].get_selection()[0]
			tmpos=app.widgets['playlist'].child_position(tmp)
			if selection:
				if playlist.up(selection):
					playlist.save()
                                        app.widgets['playlist'].select_item(tmpos-1)
	def on_add_file_clicked(evt):
		global file_location
		global status
		global rootfirst
                global temp_song_list
		rootfirst=0
		if status ==  'stopped':
			app.widgets['file_tree'].connect('select-child',toggle_song_select)
			app.widgets['file_tree'].connect('selection-get',toggle_song_select)
			leaf = GtkTreeItem(file_location+'/')
			app.widgets['file_tree'].append(leaf)
			newsubtree=GtkTree()
                        leaf.set_data('song','%s' % (file_location))
			newsubtree.connect('select-child',toggle_song_select)
			leaf.set_subtree(newsubtree)
			app.widgets['file_select'].show()
			leaf.show()
                        temp_song_list = []
			createSubTree(newsubtree,'%s/' % (file_location))
	def on_add_files_clicked(evt):
		global temp_song_list
		for each in temp_song_list:
			playlist.append(each)
		playlist.save()
		temp_song_list = []
		app.widgets['file_tree'].clear_items(0,10000000)
		app.widgets['file_select'].hide()
        def on_clear_button_clicked(evt):
                global playlist
                global status
                if status=="stopped":
                    for i in range(playlist.length()):
                        app.widgets['playlist'].select_item(0)
                        selection = app.widgets['playlist'].get_selection()
                        playlist.remove(selection)
                    playlist.save()
        
	def on_close_file_dialog_button_clicked(evt):
                global temp_song_list
		temp_song_list = []
		app.widgets['file_tree'].clear_items(0,10000000)
		app.widgets['file_select'].hide()
	def on_about_menu_activate(evt):
		app.widgets['about_dialog'].show()
	def on_okabout_button_clicked(evt):
		app.widgets['about_dialog'].hide()
	def on_close_menu_activate(evt):
		global status
		if status=="paused":
			app.toggle_stop()
			app.quit()
			mainquit()
		else:
			app.quit()
			mainquit()
        def on_info_colors1_activate(evt):
            app.widgets['csd'].show()
            if app.cm==None:
                app.drawable = app.widgets['drawingarea1'].get_window()
                app.cm=app.drawable.colormap
                app.widgets['redvs'].get_adjustment().set_value(int(app.ired))
                app.widgets['greenvs'].get_adjustment().set_value(int(app.igreen))
                app.widgets['bluevs'].get_adjustment().set_value(int(app.iblue))
        def csdexpose(da,evt):
            red=app.widgets['redvs'].get_adjustment().value
            green=app.widgets['greenvs'].get_adjustment().value
            blue=app.widgets['bluevs'].get_adjustment().value
            mycolor=app.cm.alloc(red,green,blue)
            mygc=app.drawable.new_gc()        
            mygc.foreground=mycolor
            max_width = app.drawable.width
            max_height = app.drawable.height
            draw_rectangle(app.drawable, mygc, TRUE, 0, 0, max_width, max_height)
        def on_csdselect_clicked(evt):
            red=app.widgets['redvs'].get_adjustment().value
            green=app.widgets['greenvs'].get_adjustment().value
            blue=app.widgets['bluevs'].get_adjustment().value
            app.mystyle=app.widgets['d1'].get_style().copy()
            cm=app.widgets['d1'].get_colormap()
            mcolor=cm.alloc(red,green,blue)
            app.mystyle.fg[STATE_NORMAL]=mcolor
            app.widgets['d1'].set_style(app.mystyle)
            app.widgets['d2'].set_style(app.mystyle)
            app.widgets['d3'].set_style(app.mystyle)
            app.widgets['d4'].set_style(app.mystyle)
            app.widgets['d5'].set_style(app.mystyle)
            app.widgets['d6'].set_style(app.mystyle)
            app.widgets['d7'].set_style(app.mystyle)
            app.widgets['csd'].hide()

            f = open('%s/%s'%(user_home_dir,rcfile),'r')
            rcfile_ver = string.strip(f.readline())
            playlist_file = string.strip(f.readline())
            glade_file = string.strip(f.readline())
            file_location = string.strip(f.readline())
            colors = string.strip(f.readline())
            f.close()

            colors=str(int(red))+","+str(int(green))+","+str(int(blue))
            f = open('%s/%s' % (user_home_dir, rcfile),'w')
            f.write('%s\n' % rcfile_ver)
            f.write('%s\n' % playlist_file)
            f.write('%s\n' % glade_file)
            f.write('%s\n' % file_location)
            f.write('%s\n' % colors)
            f.close()
             
        def on_csdcancel_clicked(evt):
             app.widgets['csd'].hide()
def on_progress_value_change(evt):
	global csecs,status
	if (status=="playing"):
		nsec=app.widgets['progress'].get_adjustment().value
		if (nsec!=csecs):
			#app.widgets['progress'].get_adjustment().set_value(nsec)
			app.player.set_time(nsec, (app.player.maxsecs-nsec))
			app.play(app.player.pathname,nsec)
			csecs=nsec
	
PLAYERS = [mpg123_Player()]
global app
global csecs
global mystyle

app = Application()
playlist = Playlist(app.widgets['playlist'],playlist_file)
status='stopped'
temp_song_list = []
app.setup()
app.run()
